package com.DevAsh.Admin.admin;
import io.flutter.plugin.common.MethodCall;
import io.flutter.plugin.common.MethodChannel;
import io.flutter.plugin.common.MethodChannel.MethodCallHandler;
import io.flutter.plugin.common.MethodChannel.Result;
import io.flutter.plugin.common.PluginRegistry.Registrar;
import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.widget.Button;
import android.app.ActivityManager;
import android.content.ComponentName;
import android.widget.Toast;
import android.app.admin.DevicePolicyManager;
import android.app.ActivityManager;
import android.content.Context;
import android.app.admin.DeviceAdminReceiver;
import android.content.Context;
import android.content.Intent;
import android.util.Log;
import android.widget.Toast;



/** AdminPlugin */
public class AdminPlugin implements MethodCallHandler {
  MethodChannel channel;
  Activity activity;
  AdminPlugin(Activity activity,MethodChannel channel){

    this.activity=activity;
    this.channel=channel;
    this.channel.setMethodCallHandler(this);
      
  }	

  /** Plugin registration. */
  public static void registerWith(Registrar registrar) {
    final MethodChannel channel = new MethodChannel(registrar.messenger(), "admin");
    channel.setMethodCallHandler(new AdminPlugin(registrar.activity(),channel));
  }
  DevicePolicyManager devicePolicyManager;
  ActivityManager activityManager;
  ComponentName componentName;
  int RESULT_ENABLE =11;

  @Override
  public void onMethodCall(MethodCall call, Result result) {
    devicePolicyManager = (DevicePolicyManager) activity.getSystemService(activity.DEVICE_POLICY_SERVICE);
    activityManager = (ActivityManager) activity.getSystemService(activity.ACTIVITY_SERVICE);
    componentName = new ComponentName(activity,MyDeviceAdminReceiver.class);
    boolean isActive = devicePolicyManager.isAdminActive(componentName);
    if (call.method.equals("enable")) {
      
      Intent intent = new Intent(DevicePolicyManager.ACTION_ADD_DEVICE_ADMIN);
      intent.putExtra(DevicePolicyManager.EXTRA_DEVICE_ADMIN,componentName);
      intent.putExtra(DevicePolicyManager.EXTRA_ADD_EXPLANATION,componentName);
      if(!isActive){
      activity.startActivityForResult(intent, RESULT_ENABLE);
      }
    } else  if (call.method.equals("lock")) {
      
       devicePolicyManager.lockNow();
      
    } else if(call.method.equals("setPassword")){
      Intent intent = new Intent(DevicePolicyManager.ACTION_SET_NEW_PASSWORD);
      activity.startActivity(intent);
    } else if(call.method.equals("Wipe")){
        devicePolicyManager.wipeData(0);
    } else if(call.method.equals("setCamera")){
          boolean isCheck = call.argument("isCheck");
          devicePolicyManager.setCameraDisabled(componentName,isCheck);
    } else if(call.method.equals("storageEncryption")){
      boolean isCheck = call.argument("isCheck");
      devicePolicyManager.setStorageEncryption(componentName,isCheck);
    }else if(call.method.equals("setPasswordMinLength")){
      int pwLength = call.argument("length");
      devicePolicyManager.setPasswordMinimumLength(componentName, pwLength);
    }else if(call.argument("setMaximumFailedPasswordsForWipe")){
      int maxFailedPw = call.argument("length");
      devicePolicyManager.setMaximumFailedPasswordsForWipe(componentName, maxFailedPw);
    }else if(call.argument("setPasswordExpirationTimeout")){
      long pwExpiration = call.argument("length");
      devicePolicyManager.setPasswordExpirationTimeout(componentName, pwExpiration);
    }else if(call.argument("setPasswordHistoryLength")){
      int pwHistoryLength = call.argument("length");
      devicePolicyManager.setPasswordHistoryLength(componentName, pwHistoryLength);
    }else if(call.argument("setMaximumTimeToLock")){
        long timeMs = call.argument("length");
        
        devicePolicyManager.setMaximumTimeToLock(componentName, timeMs*1000);
    }  
    
    else {
      result.notImplemented();
    }
  }


}

class MyDeviceAdminReceiver extends DeviceAdminReceiver {


  /**
   * method to show toast
   *
   * @param context the application context on which the toast has to be displayed
   * @param msg     the message which will be displayed in the toast
   */
  private void showToast(Context context, CharSequence msg) {
      Log.e("MyDeviceAdminRec...", "::>>>>1 ");
      Toast.makeText(context, msg, Toast.LENGTH_SHORT).show();
  }

  @Override
  public void onEnabled(Context context, Intent intent) {
      Log.e("MyDeviceAdminRec...", "::>>>>2 ");
      showToast(context, "Sample Device Admin: enabled");
  }

  @Override
  public CharSequence onDisableRequested(Context context, Intent intent) {
      Log.e("MyDeviceAdminRec...", "::>>>>3 ");
      return "This is an optional message to warn the user about disabling.";
  }

  @Override
  public void onDisabled(Context context, Intent intent) {
      Log.e("MyDeviceAdminRec...", "::>>>>4 ");
      showToast(context, "Sample Device Admin: disabled");
  }

  @Override
  public void onPasswordChanged(Context context, Intent intent) {
      Log.e("MyDeviceAdminRec...", "::>>>>5 ");
      showToast(context, "Sample Device Admin: pw changed");
  }

  @Override
  public void onPasswordFailed(Context context, Intent intent) {
      Log.e("MyDeviceAdminRec...", "::>>>>6 ");
      showToast(context, "Sample Device Admin: pw failed");
  }

  @Override
  public void onPasswordSucceeded(Context context, Intent intent) {
      Log.e("MyDeviceAdminRec...", "::>>>>7 ");
      showToast(context, "Sample Device Admin: pw succeeded");
  }
}



