import 'dart:async';

import 'package:flutter/services.dart';

class Admin {
  static const MethodChannel _channel =
      const MethodChannel('admin');

  static Future enable() async {
     await _channel.invokeMethod('enable');
   }
  static Future lock() async {
     await _channel.invokeMethod('lock');
  } 
  static Future setPassword() async {
     await _channel.invokeMethod('setPassword');
  } 
  static Future disableCamera(bool isCheck) async {
     await _channel.invokeMethod('setCamera',{"isCheck":isCheck});
  }
  static Future storageEncryption(bool isCheck) async {
     await _channel.invokeMethod('storageEncryption',{"isCheck":isCheck});
  }
  static Future setPasswordMinLength(int length) async {
     await _channel.invokeMethod('setPasswordMinLength',{"length":length});
  }   
  static Future setMaximumFailedPasswordsForWipe(int length) async {
     await _channel.invokeMethod('setMaximumFailedPasswordsForWipe',{"length":length});
  } 
  static Future setPasswordExpirationTimeout(double length) async {
     await _channel.invokeMethod('setPasswordExpirationTimeout',{"length":length});
  } 
  static Future setPasswordHistoryLength(int length) async {
     await _channel.invokeMethod('setPasswordHistoryLength',{"length":length});
  }
   static Future setMaximumTimeToLock(double length) async {
     await _channel.invokeMethod('setMaximumTimeToLock',{"length":length});
  }     
}
